#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SSIZE 10000

int **read_data(char *filename, int *n, int *size)
{
	int i, j, k, len;
	int n_move, msize;
	char s[SSIZE];
	FILE *fp;
	int **move;
	char *format;
	int elem;

	if ((fp = fopen(filename, "r")) == NULL) {
		printf("can't open %s\n", filename);
		return 1;
	}

	if (fgets(s, SSIZE, fp) != NULL) {
		sscanf(s, "%d %d\n", &n_move, &msize);
		printf("n_move : %d, msize : %d\n", n_move, msize);
		move = (int **)malloc(sizeof(int *) * n_move);
		for (i = 0; i < n_move; i++)
			move[i] = (int *)malloc(sizeof(int) * msize);
	}
	i = 0;
	j = 0;
	while (fgets(s, SSIZE, fp) != NULL) {
		len = strlen(s);
		j = 0;
		for (k = 0; k < len; k++) {
			if (s[k] != ' ' && s[k] != '\n') {
				elem = atoi(s + k);
				move[i][j++] = elem;
				if (s[k] == '-')
					k++;
			}
		}
		i++;
	}
	fclose(fp);

	*n = n_move;
	*size = msize;
	return move;
}

int main(int argc, char *argv[])
{
	int **fiber;
	int **move;
	int vsize, n_move, n_fiber;

	int i, j, k, l;
	int *v, *t, *m;
	int tmp;
	int **connect;

	if (argc == 3) {
		fiber = read_data(argv[1], &n_fiber, &vsize);
		move = read_data(argv[2], &n_move, &vsize); 
		printf("fiber: %d %d\n", n_fiber, vsize);
		printf("move : %d %d\n", n_move, vsize);
	} else {
		printf("usage : %s fiber_file move_file\n", argv[0]);
		return 1;
	}

	connect = (int **)malloc(sizeof(int *) * n_fiber);
	for (i = 0; i < n_fiber; i++)
		connect[i] = (int *)malloc(sizeof(int) * n_fiber);


	for (i = 0; i < n_fiber; i++) {
		for (j = i + 1; j < n_fiber; j++) {
			v = fiber[i];
			t = fiber[j];
			for (k = 0; k < n_move; k++) {
				m = move[k];
				for (l = 0; l < vsize; l++) {
					tmp = v[l] + m[l];
					#if 0
					printf("v[%d] = %d, m[%d] = %d\n", l, v[l], l, m[l]);
					printf("tmp : %d\n", tmp);
					printf("t[%d] = %d\n", l, t[l]);
					#endif
					if (tmp != t[l]) {
						break;
					}
				} 
				if (l == vsize) {
					connect[i][j] = k;
					break;
				}
			}
			if (k == n_move) {
				for (k = 0; k < n_move; k++) {
					m = move[k];
					for (l = 0; l < vsize; l++) {
						tmp = v[l] - m[l];
						if (tmp != t[l]) {
							break;
						}
					} 
					if (l == vsize) {
						connect[i][j] = k + n_move;
						break;
					}
				}
				if (k == n_move) 
					connect[i][j] = -1;
			}
		}
	}

	printf("    ");
	for (i = 0; i < n_fiber; i++)
		printf("%4d", i);
	printf("\n");
	for (i = 0; i < n_fiber; i++) {
		printf("%4d", i);
		for (j = 0; j < n_fiber; j++) {
			if (i >= j) {
				printf("    ");
			} else {
				printf("%4d", connect[i][j]);
			}
		}
		printf("\n");
	}
}

